SystemOrganization addCategory: #EpisViewCourses!

Object subclass: #BuilderGrafico
	instanceVariableNames: 'pro_grafico'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!BuilderGrafico methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 17:31'!
buildata
	|cursos|
	cursos:=ParseDictionary extractCursos .
	pro_grafico setData: cursos.
	! !

!BuilderGrafico methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 17:36'!
builvisualizador
	|visual|
	visual := MOViewRenderer new.
	visual horizontalTreeLayout. ! !

!BuilderGrafico methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 17:50'!
getgrafico! !

!BuilderGrafico methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 17:08'!
initialize 
	pro_grafico :=Grafico new.! !

BuilderGrafico subclass: #GraRectangulos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!GraRectangulos methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 17:34'!
buildata
	|cursos|
	cursos:=ParseDictionary extractCursos .
	pro_grafico setData: cursos.
	! !

!GraRectangulos methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 18:22'!
builvisualizador
	|visual|
	visual := MOViewRenderer new.
	pro_grafico setvisualizador: visual.! !

!GraRectangulos methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 17:50'!
getgrafico
	^pro_grafico.! !

!GraRectangulos methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 17:14'!
initialize 
	super initialize .! !

Object subclass: #DataWeb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!DataWeb methodsFor: 'as yet unclassified' stamp: 'ymq 11/18/2012 17:00'!
getCursosGoogleDocs:url
	"Retorna un arreglo de cursos, los cuales se obtienen del json de la direcion web url"

	| diccionario cursos |
	diccionario:=(EVC_QueryGoogleDocs uniqueInstance )contentOf: url.
	cursos:=ParseDictionary extractCursos: diccionario.
	^cursos 
! !

!DataWeb methodsFor: 'as yet unclassified' stamp: 'ymq 11/18/2012 17:00'!
initialize 
	"Inicializamos la clase padre"

	super initialize ! !

Object subclass: #Dibujar
	instanceVariableNames: 'listacursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!Dibujar methodsFor: 'as yet unclassified' stamp: 'davix 11/13/2012 11:45'!
buscar: prerequisito

1 to: (listacursos size) do: [:i|
	(((listacursos at: i)  getCodigo) = prerequisito )  ifTrue: [
			^i.
		].
	].! !

!Dibujar methodsFor: 'as yet unclassified' stamp: 'ymq 11/18/2012 17:02'!
"el codigo comentado es la parte principal solo falta relacionar codigo con posicion en el arreglo "
initialize 
	|url net salida nodes temp view tam prueba requisitos aux|
	url:='http://spreadsheets.google.com/feeds/list/0Ah1IdrYiPW6tdEJlSGJEZy1LQXVocUR2VG1NdjZOaGc/od6/public/basic?alt=json'.
	net := DataWeb new.
	salida:= net getCursosGoogleDocs: url.
	listacursos :=salida.
	"salida explore."
	
	
	"Visualizar"
	view := MOViewRenderer new.	
	tam := salida size.
	view nodes: salida forEach: [ :cls |
	view shape label text: (cls getNombre ). 
	view node: cls.
].


	1 to: tam do: [:i|
		prueba:=salida at:i.
		requisitos:=prueba getRequisitos.
		((requisitos size)~=0) ifTrue: 
		[
			1 to: (requisitos size) do:[ :j |
				
				view edges: {(salida at:(self buscar: (requisitos at:j))) -> (salida at:i)} from: #key to: #value. 
			].
		].
	].

	view horizontalTreeLayout. 
	view open.! !

Object subclass: #Director
	instanceVariableNames: 'buildergrafico'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!Director methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 18:18'!
construir
	buildergrafico buildata.
	buildergrafico builvisualizador.! !

!Director methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 17:51'!
getGrafico
	^(buildergrafico getgrafico).! !

!Director methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 18:11'!
getmodelo
	^(buildergrafico getgrafico).! !

!Director methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 18:16'!
setmodelo: graficobuilder
	buildergrafico := graficobuilder.! !

Object subclass: #EVC_Course
	instanceVariableNames: 'codigo anio semestre nombre creditos requisitos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!EVC_Course methodsFor: 'adding' stamp: 'ymq 11/8/2012 19:39'!
addRequisito: newRequisito
	"Agrega el codigo del curso que es requisito del actual"

	requisitos := requisitos,newRequisito! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 12/15/2012 15:02'!
getAnio
	"Retorna el ao al cual pertenece el curso"

	^ anio! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 16:07'!
getCodigo
	"Retorna el codigo del curso"

	^ codigo! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 16:08'!
getCreditos
	"Retorna los creditos del curso"

	^ creditos ! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 16:07'!
getNombre
	"Retorna el nombre del curso"

	^ nombre! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 16:08'!
getRequisitos
	"Retorna los requisitos  del curso"

	^ requisitos ! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 12/15/2012 15:02'!
getSemestre
	"Retorna el semestre al cual pertenece el curso"

	^ semestre ! !

!EVC_Course methodsFor: 'initialize-release' stamp: 'ymq 12/15/2012 20:07'!
initialize 
	"inicializa la super clase"

	super initialize .
	codigo := nil.
	anio:=nil.
	semestre:=nil.
	nombre := nil .
	creditos := nil.
	requisitos := #().
	! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 12/15/2012 15:03'!
setAnio: newAnio
	"Cambiar ao del Curso"

	anio  := newAnio ! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 15:40'!
setCodigo: newCodigo
	"Cambiar codigo"

	codigo := newCodigo! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 15:41'!
setCreditos: newCreditos
	"Cambiar los creditos"

	creditos := newCreditos! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 15:40'!
setNombre: newNombre
	"Cambiar nombre de Curso"

	nombre := newNombre! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 12/15/2012 15:03'!
setSemestre: newSemestre
	"Cambiar ao del Curso"

	semestre   := newSemestre ! !

Object subclass: #EVC_QueryGoogleDocs
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

EVC_QueryGoogleDocs class
	instanceVariableNames: 'unicaInstancia'!

EVC_QueryGoogleDocs class
	instanceVariableNames: 'unicaInstancia'!

!EVC_QueryGoogleDocs class methodsFor: 'as yet unclassified' stamp: 'ymq 11/18/2012 16:22'!
uniqueInstance
	"Controla que la clase solo tenga una unica instancia"
	
	unicaInstancia ifNil: [unicaInstancia := self new].
	^unicaInstancia! !

!EVC_QueryGoogleDocs methodsFor: 'as yet unclassified' stamp: 'ymq 11/18/2012 16:13'!
contentOf:url
	"Retorna un diccionario de Cursos obtenido de un JSON parseado, el cual proviene de la direccion  url"

	| parser json filas unit listCursos|
	
	parser := PPParserResource current parserAt: PPJsonParser.
	json := (Url absoluteFromText:url ) retrieveContents contents.
	result:= parser parse: json.
	
	^result ! !

!EVC_QueryGoogleDocs methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 15:06'!
initialize 
	"inicializa super clase"

	super initialize .! !

Object subclass: #FCurso
	instanceVariableNames: 'codigo anio semestre nombre creditos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!FCurso methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:19'!
getAnio
	"Retorna el ao al cual pertenece el curso"

	^ anio! !

!FCurso methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:19'!
getCodigo
	"Retorna el codigo del curso"

	^ codigo! !

!FCurso methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:19'!
getCreditos
	"Retorna los creditos del curso"

	^ creditos ! !

!FCurso methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:19'!
getNombre
	"Retorna el nombre del curso"

	^ nombre! !

!FCurso methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:19'!
getSemestre
	"Retorna el semestre al cual pertenece el curso"

	^ semestre ! !

!FCurso methodsFor: 'initialize-release' stamp: 'ymq 12/16/2012 13:19'!
initialize 
	"inicializa la super clase"

	super initialize .
	codigo := nil.
	anio:=nil.
	semestre:=nil.
	nombre := nil .
	creditos := nil.
	requisitos := #().
	! !

!FCurso methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:19'!
setAnio: newAnio
	"Cambiar ao del Curso"

	anio  := newAnio ! !

!FCurso methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:19'!
setCodigo: newCodigo
	"Cambiar codigo"

	codigo := newCodigo! !

!FCurso methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:19'!
setCreditos: newCreditos
	"Cambiar los creditos"

	creditos := newCreditos! !

!FCurso methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:19'!
setNombre: newNombre
	"Cambiar nombre de Curso"

	nombre := newNombre! !

!FCurso methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:19'!
setSemestre: newSemestre
	"Cambiar ao del Curso"

	semestre   := newSemestre ! !

FCurso subclass: #FCursoConRequisito
	instanceVariableNames: 'requisitos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!FCursoConRequisito methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 15:15'!
accept: visitor
	visitor visitconpre: self.
	 ! !

!FCursoConRequisito methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:24'!
addRequisito: newRequisito
	"Agrega el codigo del curso que es requisito del actual"

	requisitos := requisitos,newRequisito! !

!FCursoConRequisito methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:25'!
getRequisitos
	"Retorna los requisitos  del curso"

	^ requisitos ! !

!FCursoConRequisito methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:24'!
initialize 
	"inicializamos la clase base y el areglo de prerequisitos"

	super initialize .
	requisitos := #()! !

FCurso subclass: #FCursoSinRequisito
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!FCursoSinRequisito methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 15:56'!
accept: visitor
	visitor visitsinpre: self.! !

!FCursoSinRequisito methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 13:22'!
initialize 
	"inicializamos la clase base"

	super initialize ! !

Object subclass: #Grafico
	instanceVariableNames: 'cursos visual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!Grafico methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 18:28'!
mostrar
	|visitor tam curso|
	visual nodes: cursos forEach: [ :cls |
	visual shape label text: (cls getNombre ). 
	visual node: cls.
	].
	visitor:=ConcreteVisitor  new.
	visitor v: visual l: cursos. 
	tam:=cursos size.
		1 to: tam do: [:i|
		curso:=cursos at:i.
		curso accept: visitor.
	].
	visual horizontalTreeLayout.
	visual open.! !

!Grafico methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 18:26'!
setData: data
	cursos:=data.! !

!Grafico methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 18:22'!
setvisualizador: visuali
	visual :=visuali .! !

Object subclass: #Main
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!Main methodsFor: 'as yet unclassified' stamp: 'davix 12/16/2012 18:17'!
initialize 
	|director imagen_rectangulos grafico|
	director :=Director new.
	imagen_rectangulos:=GraRectangulos new.
	director setmodelo:  imagen_rectangulos.
	director construir.
	grafico:=director getmodelo.
	grafico mostrar .! !

Object subclass: #ParseDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!ParseDictionary class methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 15:18'!
extractCursos
	"Retorna un arreglo de Cursos a partir de un Dictionary que contiene estos datos"

	| dictionary filas unit listCursos listRequisitos url | 

	url := 'http://spreadsheets.google.com/feeds/list/0Ah1IdrYiPW6tdEJlSGJEZy1LQXVocUR2VG1NdjZOaGc/od6/public/values?&alt=json'.
	Transcript show: url.
	dictionary := (EVC_QueryGoogleDocs uniqueInstance ) contentOf: url .
	
	filas :=  (dictionary at:'feed')at: 'entry'.	
		
	listCursos := Array new: (filas size).
	listRequisitos := Array new: 1.
	(1 to: (filas size ))  do:  [
		:f |   | fila curso requisito|
		fila := filas at: f.
		requisito := ((fila at: 'gsx$requisitos') at:'$t').
		((requisito size) > 0)ifTrue: [
			curso := FCursoConRequisito new.
			(1 to: (requisito size/6)) do: [
				:r |    | req |
				req := requisito copyFrom: ((6*(r-1))+1) to: (6*r).
				listRequisitos at: 1 put: req .
				curso addRequisito: listRequisitos .			
			]
		] ifFalse: [curso := FCursoSinRequisito new.].
			
		curso setCodigo: ((fila at: 'gsx$codigo') at:'$t').
		curso setAnio: ((fila at: 'gsx$anio') at:'$t').
		curso setSemestre: ((fila at: 'gsx$semestre') at:'$t').
		curso setNombre: ((fila at: 'gsx$nombre') at:'$t').
		curso setCreditos: ((fila at: 'gsx$creditos') at:'$t').
				
		listCursos at: f put: curso. 
	].

	^listCursos! !

!ParseDictionary class methodsFor: 'as yet unclassified' stamp: 'ymq 12/15/2012 20:33'!
extractCursosOfAnio:varAnio andSemestre:varSemestre
	"Retorna un arreglo de Cursos a partir de un Dictionary que contiene estos datos"

	| dictionary filas unit listCursos listRequisitos sql url | 
	sql := 'sq=anio=',(varAnio asString ),'%20and%20semestre=',(varSemestre asString ). 
	url := 'http://spreadsheets.google.com/feeds/list/0Ah1IdrYiPW6tdEJlSGJEZy1LQXVocUR2VG1NdjZOaGc/od6/public/values?',(sql),'&alt=json'.
	Transcript show: url.
	dictionary := (EVC_QueryGoogleDocs uniqueInstance ) contentOf: url .
	
	filas :=  (dictionary at:'feed')at: 'entry'.	
		
	listCursos := Array new: (filas size).
	listRequisitos := Array new: 1.
	(1 to: (filas size ))  do:  [
		:f |   | fila curso requisito|
		curso := EVC_Course new.
		fila := filas at: f.
		curso setCodigo: ((fila at: 'gsx$codigo') at:'$t').
		curso setAnio: ((fila at: 'gsx$anio') at:'$t').
		curso setSemestre: ((fila at: 'gsx$semestre') at:'$t').
		curso setNombre: ((fila at: 'gsx$nombre') at:'$t').
		curso setCreditos: ((fila at: 'gsx$creditos') at:'$t').
		requisito := ((fila at: 'gsx$requisitos') at:'$t').
		(1 to: (requisito size/6)) do: [
			:r |    | req |
			req := requisito copyFrom: ((6*(r-1))+1) to: (6*r).
			listRequisitos at: 1 put: req .
			curso addRequisito: listRequisitos . 
		].
		listCursos at: f put: curso. 
	].

	^listCursos
	
	
		! !

!ParseDictionary class methodsFor: 'as yet unclassified' stamp: 'ymq 12/16/2012 14:54'!
extractCursosOfSemestre:varSemestre
	"Retorna un arreglo de Cursos a partir de un Dictionary que contiene estos datos"

	| dictionary filas unit listCursos listRequisitos sql url | 
	sql := 'sq=semestre=',(varSemestre asString ). 
	url := 'http://spreadsheets.google.com/feeds/list/0Ah1IdrYiPW6tdEJlSGJEZy1LQXVocUR2VG1NdjZOaGc/od6/public/values?',(sql),'&alt=json'.
	Transcript show: url.
	dictionary := (EVC_QueryGoogleDocs uniqueInstance ) contentOf: url .
	
	filas :=  (dictionary at:'feed')at: 'entry'.	
		
	listCursos := Array new: (filas size).
	listRequisitos := Array new: 1.
	(1 to: (filas size ))  do:  [
		:f |   | fila curso requisito|
		fila := filas at: f.
		requisito := ((fila at: 'gsx$requisitos') at:'$t').
		((requisito size) > 0)ifTrue: [
			curso := FCursoConRequisito new.
			(1 to: (requisito size/6)) do: [
				:r |    | req |
				req := requisito copyFrom: ((6*(r-1))+1) to: (6*r).
				listRequisitos at: 1 put: req .
				curso addRequisito: listRequisitos .			
			]
		] ifFalse: [curso := FCursoSinRequisito new.].
			
		curso setCodigo: ((fila at: 'gsx$codigo') at:'$t').
		curso setAnio: ((fila at: 'gsx$anio') at:'$t').
		curso setSemestre: ((fila at: 'gsx$semestre') at:'$t').
		curso setNombre: ((fila at: 'gsx$nombre') at:'$t').
		curso setCreditos: ((fila at: 'gsx$creditos') at:'$t').
				
		listCursos at: f put: curso. 
	].

	^listCursos! !
